package lab4;


import java.math.BigInteger;
import java.util.concurrent.*;


public class Primes {
	

	public Primes() {
		Runnable r1 = printPrimes(0, new BigInteger("1000000000000000"), 10000);
		Runnable r2 = printPrimes(1, new BigInteger("2000000000000000"), 10000);

		ExecutorService service = Executors.newFixedThreadPool(2);
		service.execute(r1);
		service.execute(r2);

		service.shutdown();
	}



	private Runnable printPrimes(int instance, BigInteger start, long length)
	{
		return () ->
		{
			BigInteger n = start;
			for (long i = 0; i < length; i++) 
			{
				if (n.isProbablePrime(100))
					System.out.println(n);
				n = n.add(BigInteger.ONE);
			}
			System.out.println("Instance " + instance + " thread exiting.");
		};
	} 
	

	// The distinct method is used in Part 3 of the lab.
	
	private String distinct(String s)
	{
		StringBuilder result = new StringBuilder();
		int i = 0;
		while (i < s.length())
		{
			int cp = s.codePointAt(i);
			int cc = Character.charCount(cp);
			if (result.indexOf(s.substring(i, i + cc)) == -1)
				result.appendCodePoint(cp);
			i += cc;
		}
		return result.toString();
	}


	public static void main(String[] args) {
		new Primes();
		System.out.println("Main thread exiting");
	}

	
}
